// Tied closely to manage_project.jsp.
// Not useful anywhere else.

(function() {

	var $ = dojo.byId;
	var $$ = dojo.query;

	// Project IDs to the div for that project.
	// Only project is visible at once.
	var gProjectDivs = {};
	// Used to generate on the fly project ID attribute.
	var gNextProjectIdCount = 0;

	// That attributes that are in in use in the projects.
	// Until we load a project, we don't know what the list is, so
	// start with the know built-in attributes.
	var gFavoriteAttributes = new FavoriteAttributes();

/*************
	copied
	**************/

var MORE_ATTRIBUTES = '<<<com.telelogic.pseudoAttr.moreAttributes>>>';
var DIVIDER_VALUE = '<<<com.telelogic.pseudoAttr.divider>>>>';
var DIVIDER_TEXT = '----------';


function removeChildren(node)
{
	$$(node).empty();
}


function drawValueWidget(attributeName, valueNode, initialValue)
{
	var newValue;

	if (attributeName === window.MORE_ATTRIBUTES)
	{
		// we shouldn't normally get here. Only if the user has no attributes defined in the lifecycle.
		var selectNote = document.createElement('DIV');
		selectNote.className = 'note';
		selectNote.appendChild(document.createTextNode(
			'MORE Attributes Info... TODO'));
		newValue = selectNote;
	}
	else
	{
		var attribute = window.gAttributeMap[attributeName];
		
		var type = (attribute)
			? attribute.type
			: 'CCM_STRING';
		
		if (window.AclExport && attributeName == AclExport.ATTRIBUTE_NONE)
		{
			type = '{all}';
		}

		switch (type)
		{
			case '{all}':
				newValue = document.createDocumentFragment();
				break;
			case 'CCM_TOGGLE':
				newValue = TypeFragments.createListboxFragment(attribute.values, initialValue);
				break;
			case 'CCM_LISTBOX':
				if (attribute.isDependent)
				{
					newValue = TypeFragments.createShyboxFragmentWithListboxIcon(attribute.values, initialValue);
				}
				else
				{
					newValue = TypeFragments.createShyboxFragment(attribute.values, initialValue);
				}
				break;
			case 'CCM_VALUELISTBOX':
				newValue = TypeFragments.createValueListboxFragment(attribute.values);
				break;
			case 'CCM_USER':
				newValue = TypeFragments.createUserShyboxFragment(initialValue);
				break;
			case 'relationship':
			default: // all others, e.g. CCM_STRING, CCM_TEXT
				newValue = TypeFragments.createTextFragment(initialValue);
		}
	}

	removeChildren(valueNode);
	valueNode.appendChild(newValue);
}



/************end copied **************/



	function ancestor(child, parentNodeName)
	{
		var parent = child.parentNode;
		while (parent)
		{
			if (parent.nodeName == parentNodeName.toUpperCase()) return parent;
			parent = parent.parentNode;
		}
	}

	function hideProjects()
	{
		$$('#projects > *').style('display', 'none');
	}
	
	function restripeTable(table)
	{
		table = table.nodeName == 'TABLE' ? table : ancestor(table, 'TABLE');
		$$(table).query('.odd-row').removeClass('odd-row');
		$$(table).query('tr:nth-child(odd)').addClass('odd-row');
	}
	
	function newRoleRow()
	{
		var row = $('role-row-template').cloneNode(true);
		row.removeAttribute('id');
		return row;
	}

	function newAttributeRow()
	{
		var row = $('attribute-row-template').cloneNode(true);
		row.removeAttribute('id');
		console.log(row.cells[0]);
		$$(row.cells[0]).empty().adopt(gFavoriteAttributes.createSelect());
		return row;
	}

	function addRowAfter(after, row)
	{
		dojo.place(row, after, 'after');
		restripeTable(row);

		var cells = dojo.query('td', row);
//		var oldColor = cells.style('backgroundColor');
//		console.log('from yellow to ' + oldColor);
		cells.style('backgroundColor', 'yellow');

		cells.anim(
			{'backgroundColor': 'white'},
			500,
			null,
			function() { cells.style('backgroundColor', ''); }
			);
	}
	
	function deleteRow(row)
	{
		dojo.addClass(row, 'deleting');

		if (!window.confirm('Delete row?'))
		{
			dojo.removeClass(row, 'deleting');
		}
		else
		{
			var table = ancestor(row, 'table');
			row.parentNode.removeChild(row);
			restripeTable(table);
		}
	}

	function docOnClick(e)
	{
		var target = e.target

		if (dojo.hasClass(target, 'add-attribute'))
		{
			dojo.stopEvent(e);
			addRowAfter(ancestor(target, 'TR'), newAttributeRow());
		}
		else if (dojo.hasClass(target, 'delete-role'))
		{
			dojo.stopEvent(e);
			deleteRow(ancestor(target, 'TR'));
		}
		else if (dojo.hasClass(target, 'add-role'))
		{
			dojo.stopEvent(e);
			var newRow = newRoleRow();
			attachUsersPopup(newRow);
			addRowAfter(ancestor(target, 'TR'), newRow);
		}
		else if (dojo.hasClass(target, 'delete-attribute'))
		{
			dojo.stopEvent(e);
			deleteRow(ancestor(target, 'TR'));
		}

	}
	
	function attachUsersPopup(parent)
	{
		console.log('attaching to ' + parent);
		var button = $$(parent).query('.users-button')[0];
		var usersDialog = dijit.byId('users-popup');

		button = new dijit.form.DropDownButton({
			dropDown: usersDialog,
			label: 'Edit'
		}, button);

		$$(parent).query('.users-list').onclick(function() {
			button._toggleDropDown();
			});
	}
	
	/**
	 * Tracks the list of "favorite" attributes that the user sees in attribute
	 * selects. Initially, most are hidden. The user manually adds more, or
	 * we auto add ones as projects are loaded with some in use already.
	 */
	function FavoriteAttributes()
	{
		this.favoriteSet = {'problem_number': true};
		this.favoriteList = ['problem_number'];
	}
	
	FavoriteAttributes.prototype._updateSelects = function(newAttributes)
	{
		$$(projectDiv).query('.project .attribute-name select').forEach(function(select)
		{
			
		});
	};
	
	FavoriteAttributes.prototype.updateSelect = function(select, selectedAttribute)
	{	
		select.options.length = 0;

		for (var i = 0; i < this.favoriteList.length; i++)
		{
			var attribute = this.favoriteList[i];
			SelectUtils.addOption(select, attribute, attribute, selectedAttribute == attribute);
		}
		
		// Always present at bottom
		// ------
		// More....
		SelectUtils.addOption(select, DIVIDER_TEXT, DIVIDER_VALUE).disabled = true;
		SelectUtils.addOption(select, 'More...', MORE_ATTRIBUTES);
		
		return select;
	};

		
	FavoriteAttributes.prototype.createSelect = function(selectedIndex)
	{
		var selectedIndex = selectedIndex || 0;
		var select = document.createElement('SELECT');
		return this.updateSelect(select);
	};

	FavoriteAttributes.prototype.add = function(newAttributes)
	{
		var dirty = false;
		var self = this;
		
		for (var i = 0; i < newAttributes.length; i++)
		{
			var name = newAttributes[i];
			if (!this.favoriteSet[name])
			{
				this.favoriteSet[name] = true;
				this.favoriteList.push(name);
				dirty = true;
			}
		}
		
		if (dirty)
		{
			this.favoriteList.sort();
			console.log('Favorite attributes: ' + this.favoriteList.join(', '));
		}
	}

	FavoriteAttributes.prototype.addFromProject = function(projectDiv)
	{
		var dirty = false;
		var self = this;
		
		var attributes = [];

		$$(projectDiv).query('.attribute-name select').forEach(function(select) {
			attributes.push(SelectUtils.getSelectedValue(select));
		});
		
		this.add(attributes);
	};

	function loadProject(name, html)
	{
		hideProjects();
		var newId = 'cr-project-' + gNextProjectIdCount++;
		
		gProjectDivs[name] = newId;
		
		// Each project we load goes into its own div. We only show one at a time.
		// (If the user clicks a project that's already loaded, we'll just show the
		// existing div for it instead of creating a new one.)
		var projectDiv = document.createElement('div');
		projectDiv.id = newId;
		projectDiv.innerHTML = html;
		projectDiv.className = 'project';

		$$(projectDiv).query('.value-node').forEach(function(valueNode) {
			var value = valueNode.innerHTML;
			var name = dojo.attr(valueNode, 'initialName');
			console.log(name + ' == ' + value);
			drawValueWidget(name, valueNode, value);
		});
		
		$('projects').appendChild(projectDiv);
		
		// Collect new favorite (in use) attributes from the loaded project,
		// then update the attribute selects in the new project with these attributes.
		gFavoriteAttributes.addFromProject(projectDiv);

		$$(projectDiv).query('.attribute-name select').forEach(function(select) {
			var value = SelectUtils.getSelectedValue(select);
			gFavoriteAttributes.updateSelect(select, value);
		});

		// Add popup widget to pick users
		dojo.query('.users-cell', projectDiv).forEach(function(cell) {
			attachUsersPopup(cell);
		});

		// Focus on first input for the project. Probably name.
//		$$(projectDiv).query('input')[0].focus();
	}
	
	function changeProject(item, treeNode)
	{
		
		// Check if we already loaded this project into a div.
		// If so, we'll just hide the current project and show the existing div.
		var name = item.name;
		if (gProjectDivs[name])
		{
			hideProjects();
			$$('#' + gProjectDivs[name]).style('display', '');
		}
		else
		{
			// First time we clicked this, so get from server first.
			hideProjects(true);
			dojo.xhrGet({
				url: '/change/project',
				content: {'project': item.name },
				load: function(html) { loadProject(item.name, html); },
				error: function(error) { alert(error); }
				});
		}
	}

	function newProject(e)
	{
		dojo.stopEvent(e);
	}

	dojo.addOnLoad(function() {
		var store = new dojo.data.ItemFileReadStore({
			data: gProjectData
		});

		 var treeModel = new dijit.tree.ForestStoreModel({
			  store: store,
			  rootId: "root",
			  rootLabel: "Projects",
			  childrenAttrs: ["children"]
		 });

		 var tree = new dijit.Tree({
			  model: treeModel,
			  showRoot: false
		 }, "treeOne");

		dojo.connect(tree, 'onClick', changeProject);

		dojo.connect(tree, 'onClick', function(item, treeNode) {
			console.log(this.lastLoaded);
			if (this.lastLoaded)
			{
				dojo.removeClass(this.lastLoaded.labelNode, 'last-focused');
			}
			dojo.addClass(treeNode.labelNode, 'last-focused');
			this.lastLoaded = treeNode;
		});

		dojo.connect($('intro-new-project'), 'onclick', newProject);
		dojo.connect(document, 'onclick', docOnClick);

		// console.dir(tree);
		 // tree.getLabel = function(e) {console.log(e); return 'jay!';};
		document.body.style.visibility = 'visible';
	});
})();
