	
/******************** begin subhelp.js **************************/

	/*
	 * subhelp.js
	 *
	 * Find out what help page to load for the user when they want to find
	 * out more information about the page they are on.
	 *
	 * PARAMETERS
	 * UserRole:	The current role of the user.
	 * helpID:		Integer value corresponding to a page to a help page to load.
	 *
	 */
	
	var helpWin = null;
	
	function isAscii(aInt)
	{
		// Test [a - z]
		if((aInt > 96) && (aInt < 123))
			return(true);
	
		// Test [A - Z]
		if((aInt > 64) && (aInt < 91))
			return(true);
	
		// Test [0 - 9]
		if((aInt > 47) && (aInt < 58))
			return(true);
	
		// Test [\]
		if(aInt == 92)
			return(true);
	
		// Test [/]
		if(aInt == 47)
			return(true);
	
		// Test [_]
		if(aInt == 95)
			return(true);
	
		// Test [.]
		if(aInt == 46)
			return(true);
	
		return(false);
	}
	
	function EncodeRoleName(aStr)
	{
		var i,j,z;
		var x,y;
		var retVal = "";
	
		for(i=0, j=aStr.length; i<j; i++)
		{
			x = aStr.charCodeAt(i);
			
			if(isAscii(x))
			{
				retVal = retVal + aStr.charAt(i);
			}
			else
			{
				retVal = retVal + "_";
	
				y = Number(x).toString(16);
				z = y.length;
	
				if(x > 255)
				{
					if(z == 1)
						retVal = retVal + "000";
					else if(z == 2)
						retVal = retVal + "00";
					else if(z == 3)
						retVal = retVal + "0";
				}
				else
				{
					if(z == 1)
						retVal = retVal + "0";
				}
	
				retVal = retVal + y;
			}
		}
	
		return(retVal);
	}
	
	function openHelp(UserRole, helpID)
	{
		var helpPage;
		var helpRole;
	
		if(UserRole == "Admin")
		{
			helpRole = "admin";
		}
		else if(UserRole == "User")
		{
			helpRole = "user";
		}
		else if(UserRole == "CRUser")
		{
			helpRole = "user";
		}
		else if(UserRole == "ReportBuilder")
		{
			helpRole = "reportbuilder";
		}
		else
		{
			// Use this function to encode a unicode role name into
			// the ascii value that will map to the custom role specific
			// help directory name, created during package installation.
			//
			// var unicodeRoleName = EncodeRoleName(UserRole);
	
			// The default is the standard 'User' help.
			helpRole = "user";
		}
	
		helpPage = "<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=TRAPEZE_PATH --><!-- /WSLET -->help/" + helpRole + "/";
	
		switch(helpID)
		{
			//case 0:
			//	helpPage += "admin.html";
			//break;
			case 1:
				helpPage += "query.html";
			break;
			case 2:
				helpPage += "report.html";
			break;
			case 3:
				helpPage += "show.html";
			break;
			case 4:
				helpPage += "submit.html";
			break;
			case 5:
				helpPage += "transition.html";
			break;
			case 6:
				helpPage += "getting_started4.html";
			break;
			//case 7:
			//	helpPage += "transition1.html";
			//break;
			//case 8:
			//	helpPage += "transition2.html";
			//break;
			//case 9:
			//	helpPage += "transition3.html";
			//break;
			//case 10:
			//	helpPage += "transition4.html";
			//break;
			//case 11:
			//	helpPage += "transition5.html";
			//break;
			case 14:
				helpPage += "create_attach.html";
			break;
			case 15:
				helpPage += "settings2.html";
			break;
			case 17:
				helpPage += "create_task.html";
			break;
			case 18:
				helpPage += "show_task.html";
			break;
			case 19:
				helpPage += "getting_started5.html";
			break;
			case 20:
				helpPage += "lifecycle.html";
			break;
			case 21:
				helpPage += "crprocess_file.html";
			break;
			case 22:
				helpPage += "genl_admin_tab.html";
			break;
			case 23:
				helpPage += "user_admin_tab.html";
			break;
			case 24:
				helpPage += "listboxes_tab.html";
			break;
			case 25:
				helpPage += "cspackage_tab.html";
			break;
			case 26:
				helpPage += "debug_tab.html";
			break;
			case 27:
				helpPage += "search.html";
			break;
			case 28:
				helpPage += "server_tab.html";
			break;
			case 30:
				helpPage += "build_reports2.html";
			break;
			case 31:
				helpPage += "build_reports.html";
			break;
			case 32:
				helpPage += "groups_tab.html";
			break;
			case 33:
				helpPage += "acls_tab.html";
			break;
			case 34:
				helpPage += "home_page.html";
			break;
			case 35:
				helpPage += "man_browse_user.html";
			break;
			case 36:
				helpPage += "set_def_hp_user.html";
			break;
			case 37:
				helpPage += "home_page_def.html";
			break;
			case 38:
				helpPage += "man_def_browse.html";
			break;
			case 39:
				helpPage += "assign_def_hp.html";
			break;
			case 40:
				helpPage += "assign_def_browse.html";
			break;
			case 41:
				helpPage += "search_tab.html";
			break;
			case 42:
				helpPage += "ghosts_tab.html";
			break;
			case 43:
				helpPage += "manage_fldrs7.html";
			break;
			
			default:
				helpPage += "changesynergy.html";
			break;
		}
	
		// To see what you are going to open
		//alert(helpPage);
	
		helpWin = window.open(helpPage, 'WWHFrame', '<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=USER_WINDOW_OPTIONS --><!-- /WSLET -->');
		helpWin.focus();
	}
	
	function openautoHelp(Url)
	{
		helpWin = window.open(Url, 'WWHFrame', '<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=USER_WINDOW_OPTIONS --><!-- /WSLET -->');
		helpWin.focus();
	}

	function openApiHelp()
	{
		var url = "<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=TRAPEZE_PATH --><!-- /WSLET -->help/perl_api/index.html";
		var w = window.open(url, "PerlApi", "<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=USER_WINDOW_OPTIONS --><!-- /WSLET -->");
		w.focus();
	}
	
/******************** end subhelp.js **************************/
